unit ServerController;

interface

uses
  SysUtils, Classes, IWServerControllerBase, IWBaseForm, HTTPApp, IWBSInput, IWDBStdCtrls,
  // For OnNewSession Event
  UserSessionUnit, IWApplication, IWAppForm, IW.Browser.Browser,
  IW.HTTP.Request, IW.HTTP.Reply;

type
  TIWServerController = class(TIWServerControllerBase)
    procedure IWServerControllerBaseNewSession(ASession: TIWApplication);
    procedure IWServerControllerBaseConfig(Sender: TObject);

  private
    { Private declarations }

  public
    { Public declarations }
  end;

  function UserSession: TIWUserSession;
  function IWServerController: TIWServerController;

implementation

{$R *.dfm}

uses
  IWInit, IWGlobal, IWBSGlobal;

procedure MyBeforeRender(AControl: TComponent);
begin
  if AControl is TIWBSSelect then
    TIWBSSelect(AControl).Css := 'selectpicker';
  if AControl is TIWDBLookupComboBox then
    TIWDBLookupComboBox(AControl).Css := 'selectpicker width100 col-md-12';
end;
function IWServerController: TIWServerController;
begin
  Result := TIWServerController(GServerController);
end;

function UserSession: TIWUserSession;
begin
  Result := TIWUserSession(WebApplication.Data);
end;

{ TIWServerController }

procedure TIWServerController.IWServerControllerBaseConfig(Sender: TObject);
begin
  JavaScriptOptions.RenderjQuery := False;

//  ContentFiles.Add('/files/styles.css');
//  ContentFiles.Add('/files/funcoes.js');

  IWBSLibSetCDNS;

//  IWBSAddGlobalLinkFile('https://cdn.jsdelivr.net/npm/bootstrap-select@1.13.18/dist/css/bootstrap-select.min.css');
//  IWBSAddGlobalLinkFile('https://cdn.jsdelivr.net/npm/bootstrap-select@1.13.18/dist/js/bootstrap-select.min.js');
end;

procedure TIWServerController.IWServerControllerBaseNewSession(
  ASession: TIWApplication);
begin
  ASession.Data := TIWUserSession.Create(nil, ASession);
end;

initialization
  TIWServerController.SetServerControllerClass;

  // set global events
//  gIWBSOnRenderAsync := MyRenderAsync;
//  gIWBSOnBeforeRender := MyBeforeRender;
  gIWBSOnRender := MyBeforeRender;

end.

